#!/usr/bin/perl

use strict;
use utf8;
use FileHandle;
use Getopt::Long;
use List::Util qw(sum min max shuffle);
binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
binmode STDERR, ":utf8";

if(@ARGV != 1) {
    print STDERR "Usage: $0 SIZE\n";
    exit 1;
}

my $str;
while($str = <STDIN>) {
    chomp $str;
    my @sizes = map { scalar(split(/ /, $_)) } split(/\t/, $str);
    if((min(@sizes) > 0) and (max(@sizes) <= $ARGV[0])) {
        print "$str\n";
    }
}
