#!/bin/bash

mkdir -p aligned tok

./extract-sents.pl 0 all.ids MultiUN.ar-en.en > aligned/all.en
./extract-sents.pl 0 all.ids MultiUN.ar-en.ar > aligned/all.ar
./extract-sents.pl 1 all.ids MultiUN.en-es.es > aligned/all.es
./extract-sents.pl 2 all.ids MultiUN.en-fr.fr > aligned/all.fr
./extract-sents.pl 3 all.ids MultiUN.en-ru.ru > aligned/all.ru
./extract-sents.pl 4 all.ids MultiUN.en-zh.zh > aligned/all.zh

../work/mosesdecoder/scripts/tokenizer/tokenizer.perl -l en < aligned/all.en > tok/all.en &
../work/mosesdecoder/scripts/tokenizer/tokenizer.perl -l ar < aligned/all.ar > tok/all.ar &
../work/mosesdecoder/scripts/tokenizer/tokenizer.perl -l es < aligned/all.es > tok/all.es &
../work/mosesdecoder/scripts/tokenizer/tokenizer.perl -l fr < aligned/all.fr > tok/all.fr &
../work/mosesdecoder/scripts/tokenizer/tokenizer.perl -l ru < aligned/all.ru > tok/all.ru &
cat aligned/all.zh | sed 's/ //g' |  ..//work/kytea/src/bin/kytea -model ~/work/kytea-data/msr-0.4.0-5.mod > tok/all.zh &

wait

paste tok/* | ./clean.pl > all.clean

mkdir clean

cat all.clean | cut -f 1 > clean/ar.txt
cat all.clean | cut -f 2 > clean/en.txt
cat all.clean | cut -f 3 > clean/es.txt
cat all.clean | cut -f 4 > clean/fr.txt
cat all.clean | cut -f 5 > clean/ru.txt
cat all.clean | cut -f 6 > clean/zh.txt
