#!/usr/bin/perl

use strict;
use warnings;
use utf8;
use Getopt::Long;
use List::Util qw(sum min max shuffle);
binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
binmode STDERR, ":utf8";

my $LANG = "en";
GetOptions(
"lang=s" => \$LANG,
);

if(@ARGV != 3) {
    print STDERR "Usage: $0 COL IDFILE TXTFILE\n";
    exit 1;
}

my $col = $ARGV[0];

open FILE1, "<:utf8", $ARGV[1] or die "Couldn't open $ARGV[1]\n";
my @ids = map { chomp; my @arr = split(/ /); $arr[$col] } <FILE1>;
close FILE1;

open FILE2, "<:utf8", $ARGV[2] or die "Couldn't open $ARGV[2]\n";
my @lines = <FILE2>;
close FILE2;

for(@ids) {
    print $lines[$_-1];
}
