#!/usr/bin/perl

use strict;
use utf8;
use FileHandle;
use Getopt::Long;
use List::Util qw(sum min max shuffle);
binmode STDIN, ":utf8";
binmode STDOUT, ":utf8";
binmode STDERR, ":utf8";


# Get the IDS
my %ids;
while(<STDIN>) {
    chomp;
    $ids{$_} = scalar(keys(%ids));
}   

my @all_ids = map { [] } keys %ids;
foreach my $i (0 .. $#ARGV) {
    open FILE, "<:utf8", $ARGV[$i] or die "Couldn't open $ARGV[$i]\n";
    my $line = 1;
    while(<FILE>) {
        chomp;
        if(exists $ids{$_}) {
            $all_ids[$ids{$_}]->[$i] = $line;
        }
        $line++;
    }
    close FILE;
}

for(@all_ids) {
    my $cnt = sum(map { $_ ? 1 : 0 } @$_);
    if($cnt == @ARGV) {
        print "@$_\n";
    }
}

