#!/bin/bash

TRAVDIR=$HOME/work/travatar
MULTDIR=$HOME/work/multi-extract
LC=$TRAVDIR/script/tree/lowercase.pl
ZHMODEL=$HOME/data/kytea/model/msr-0.4.0-5.mod


# Split into training and test sets
mkdir -p data/orig
for f in data/clean/*; do
    f1=`basename $f .txt`;
    head -n 4500 $f | awk 'NR%3==1' > data/orig/dev.$f1
    head -n 4500 $f | awk 'NR%3==2' > data/orig/devtest.$f1
    head -n 4500 $f | awk 'NR%3==0' > data/orig/test.$f1
    for lines in 4000000 2000000 1000000 0400000 0200000 0100000 0040000 0020000 0010000 0004000 0002000 0001000; do
        cat $f | tail -n +4500 | head -n $lines > data/orig/train-$lines.$f1
    done
done

mv data/orig tok

# Creating combinations
for data in dev devtest test; do
for trg1 in en ar fr zh ru es; do
for trg2 in en ar fr zh ru es; do
    if [[ $trg1 == $trg2 ]]; then continue; fi
    echo "paste tok/$data.$trg1 tok/$data.$trg2 | sed 's/\t/ |COL| /g' > tok/$data.$trg1$trg2" 
    paste tok/$data.$trg1 tok/$data.$trg2 | sed 's/\t/ |COL| /g' > tok/$data.$trg1$trg2 
done
done
done
