#!/bin/bash
set -e

TRAVDIR=$HOME/work/travatar
GIZADIR=$HOME/work/giza-pp
WD=`pwd`

mkdir -p standard-model

for LMSIZE in 0100000; do
for TMSIZE in 0100000; do
for TRG in ar es fr ru zh; do
for SRC in en; do
# for SRC in ar fr ru zh; do
# for TRG in en; do
    if [[ $SRC == $TRG ]]; then continue; fi
    # Make the LM
    LMID=$TRG-lm$LMSIZE
    mkdir -p lm
    if [[ ! -e lm/$LMID.arpa ]]; then
        echo "Creating $TRG LM"
        echo "$TRAVDIR/src/kenlm/lm/lmplz -S 50% -o 5 < tok/train-$LMSIZE.$TRG > lm/$LMID.arpa"
        $TRAVDIR/src/kenlm/lm/lmplz -S 50% -o 5 < tok/train-$LMSIZE.$TRG > lm/$LMID.arpa
        echo "$TRAVDIR/src/kenlm/lm/build_binary lm/$LMID.arpa lm/$LMID.blm"
        $TRAVDIR/src/kenlm/lm/build_binary lm/$LMID.arpa lm/$LMID.blm
        touch lm/$LMID.done
    fi
    # Make the TM
    TMID=$SRC$LMID-tm$TMSIZE
    if [[ -e lm/$LMID.blm ]] && [[ ! -e standard-model/$TMID ]]; then
        echo "Creating $SRC$TRG TM"
        echo "$TRAVDIR/script/train/train-travatar.pl -threads 4 -bin_dir $GIZADIR -travatar_dir $TRAVDIR -method hiero -src_file tok/train-$TMSIZE.$SRC -trg_file tok/train-$TMSIZE.$TRG -work_dir $WD/standard-model/$TMID -lm_file lm/$LMID.blm"
        $TRAVDIR/script/train/train-travatar.pl -threads 4 -bin_dir $GIZADIR -travatar_dir $TRAVDIR -method hiero -src_file tok/train-$TMSIZE.$SRC -trg_file tok/train-$TMSIZE.$TRG -work_dir $WD/standard-model/$TMID -lm_file lm/$LMID.blm
    fi
    # Filter the TM
    if [[ -e standard-model/$TMID/model/travatar.ini ]]; then
        for f in dev devtest test; do
            if [[ ! -e standard-model/$TMID/filtered-$f ]]; then
                echo "$TRAVDIR/script/train/filter-model.pl standard-model/$TMID/model/travatar.ini standard-model/$TMID/filtered-$f.ini standard-model/$TMID/filtered-$f  \"$TRAVDIR/script/train/filter-rt.pl -src-format word -src tok/$f.$SRC\" &"
                $TRAVDIR/script/train/filter-model.pl standard-model/$TMID/model/travatar.ini standard-model/$TMID/filtered-$f.ini standard-model/$TMID/filtered-$f  "$TRAVDIR/script/train/filter-rt.pl -src-format word -src tok/$f.$SRC" &
            fi 
        done
    fi
done
done
done
done
