#!/bin/bash
set -e

TRAVDIR=$HOME/work/travatar
WD=`pwd`
THREADS=21
SPAN=10

mkdir -p multi-tune
for EVAL in b0; do
for POPLIM in 02000; do
for SRC in en; do
# for TRG0 in es fr ar ru zh; do
for TRG0 in fr; do
for TRG1 in es fr ar ru zh; do
    # for f in multi-model/$SRC$TRG0$TRG1-lm0100000x[04]000000-tm0100000-f{std,lim0}; do
    # for f in multi-model/$SRC$TRG0$TRG1-lm0[10]00000x[04]000000-tm0100000-flim0 multi-model/$SRC$TRG0$TRG1-lm0100000x4000000-tm0100000-fstd multi-model/$SRC$TRG0$TRG1-lm0100000x0000000-tm0100000-fsrc; do
    for f in multi-model/$SRC$TRG0$TRG1-lm*x[04]000000-tm0100000-flim0 multi-model/$SRC$TRG0$TRG1-lm0100000x4000000-tm0100000-fstd multi-model/$SRC$TRG0$TRG1-lm0100000x0000000-tm0100000-fsrc; do
        echo $f
        f1=`basename $f`;
        TID=$f1-sp$SPAN-pl$POPLIM-e$EVAL
        if [[ $EVAL == "b01" ]]; then
            EVALSTR='interp:0.5|bleu:factor=0|0.5|bleu:factor=1'
        elif [[ $EVAL == "b0" ]]; then
            EVALSTR='bleu:factor=0'
        else
            EVALSTR=bleu
        fi
        if [[ $f == *src* ]]; then
            FACT=1
            OUTSUF=$TRG0
        else
            FACT=2
            OUTSUF=$TRG0$TRG1
        fi
        # Tune
        if [[ -e $f/filtered-dev.ini ]] && [[ ! -e multi-tune/$TID ]]; then
            echo "$TRAVDIR/script/mert/mert-travatar.pl -eval \"$EVALSTR\" -trg-factors $FACT -decoder-options \"-hiero_span_limit '$SPAN 1000' -search cp -pop_limit $POPLIM\" -threads $THREADS -no-filter-rt -travatar-config $f/filtered-dev.ini -src tok/dev.$SRC -ref tok/dev.$OUTSUF -travatar-dir $TRAVDIR -working-dir $WD/multi-tune/$TID &> log/tune-$TID.log"
            $TRAVDIR/script/mert/mert-travatar.pl -eval "$EVALSTR" -trg-factors $FACT -decoder-options "-hiero_span_limit '$SPAN 1000' -search cp -pop_limit $POPLIM" -threads $THREADS -no-filter-rt -travatar-config $f/filtered-dev.ini -src tok/dev.$SRC -ref tok/dev.$OUTSUF -travatar-dir $TRAVDIR -working-dir $WD/multi-tune/$TID &> log/tune-$TID.log
        fi
        # Test
        if [[ -e multi-tune/$TID/travatar.ini ]]; then
            for data in test; do
                # for algot in cp cpcon inccon; do
                for algot in cp; do
                if [[ $f == *x0000000* ]] && [[ $algot == *con ]]; then continue; fi
                if [[ $f == *x4000000* ]] && [[ $algot == inc ]]; then continue; fi
                # for TPOPLIM1 in 02000; do
                # for TPOPLIM in $POPLIM; do
                # for TPOPLIM1 in 02000 01000 00400 00200 00100 00040 00020 00010; do
                for TPOPLIM1 in 02000; do
                for TPOPLIM2 in 00010 00100; do
                    if [[ $algot == "cp" ]]; then algoid=tl; multi=joint; algo=cp; TPOPLIM=$TPOPLIM1; fi
                    if [[ $algot == "inc" ]]; then algoid=ti; multi=joint; algo=inc; TPOPLIM=$TPOPLIM1; fi
                    if [[ $algot == "cpcon" ]]; then algoid=tlc; multi=consec; algo=cp; TPOPLIM="$TPOPLIM1 $TPOPLIM2"; fi
                    if [[ $algot == "inccon" ]]; then algoid=tic; multi=consec; algo=inc; TPOPLIM="$TPOPLIM1 $TPOPLIM2"; fi
                    TPID=`echo $TPOPLIM | sed 's/ /x/g'`
                    SID=$TID-$algoid$TPID
                    mkdir -p multi-test/$SID
                    if [[ ! -e multi-test/$SID/travatar-$data.ini ]]; then
                        sed "s/filtered-dev/filtered-$data/g" < multi-tune/$TID/travatar.ini > multi-test/$SID/travatar-$data.ini
                        echo "$TRAVDIR/src/bin/travatar -lm_multi_type $multi -trace_out multi-test/$SID/$data.trace -trg_factors $FACT -nbest 20 -nbest_out multi-test/$SID/$data.nbest -hiero_span_limit '$SPAN 1000' -search $algo -pop_limit \"$TPOPLIM\" -config_file multi-test/$SID/travatar-$data.ini -threads $THREADS < tok/$data.$SRC > multi-test/$SID/$data.out 2> multi-test/$SID/$data.err"
                        $TRAVDIR/src/bin/travatar -lm_multi_type $multi -trace_out multi-test/$SID/$data.trace -trg_factors $FACT -nbest 20 -nbest_out multi-test/$SID/$data.nbest -hiero_span_limit "$SPAN 1000" -search $algo -pop_limit "$TPOPLIM" -config_file multi-test/$SID/travatar-$data.ini -threads $THREADS < tok/$data.$SRC > multi-test/$SID/$data.out 2> multi-test/$SID/$data.err
                        echo "$TRAVDIR/src/bin/mt-evaluator -eval "$EVALSTR" -ref tok/$data.$OUTSUF multi-test/$SID/$data.out > multi-test/$SID/$data.eval"
                        $TRAVDIR/src/bin/mt-evaluator -eval "$EVALSTR" -ref tok/$data.$OUTSUF multi-test/$SID/$data.out > multi-test/$SID/$data.eval
                        $TRAVDIR/src/bin/mt-evaluator -eval "bleu:factor=0 ribes:factor=0" -ref tok/$data.$OUTSUF multi-test/$SID/$data.out > multi-test/$SID/$data.eval0
                        $TRAVDIR/src/bin/mt-evaluator -eval "bleu:factor=1 ribes:factor=0" -ref tok/$data.$OUTSUF multi-test/$SID/$data.out > multi-test/$SID/$data.eval1
                    fi
                done
                done
                done
            done
        fi
    done
done
done
done
done
done
