#!/bin/bash
set -e

TRAVDIR=$HOME/work/travatar
WD=`pwd`
SRC=en
THREADS=21
SPAN=10

mkdir -p standard-tune
for POPLIM in 02000; do
for SRC in en; do
for TRG in ar es fr en ru zh; do
    for f in standard-model/$SRC$TRG*; do
        f1=`basename $f`;
        TID=$f1-sp$SPAN-pl$POPLIM
        # Tune
        if [[ -e $f/filtered-dev.ini ]] && [[ ! -e standard-tune/$TID ]]; then
            echo "$TRAVDIR/script/mert/mert-travatar.pl -decoder-options \"-hiero_span_limit '$SPAN 1000' -pop_limit $POPLIM -search cp\" -threads $THREADS -no-filter-rt -travatar-config $f/filtered-dev.ini -src tok/dev.$SRC -ref tok/dev.$TRG -travatar-dir $TRAVDIR -working-dir $WD/standard-tune/$TID &> log/tune-$TID.log"
            $TRAVDIR/script/mert/mert-travatar.pl -decoder-options "-hiero_span_limit '$SPAN 1000' -pop_limit $POPLIM -search cp" -threads $THREADS -no-filter-rt -travatar-config $f/filtered-dev.ini -src tok/dev.$SRC -ref tok/dev.$TRG -travatar-dir $TRAVDIR -working-dir $WD/standard-tune/$TID &> log/tune-$TID.log
        fi
        # Test
        if [[ -e standard-tune/$TID/travatar.ini ]]; then
            for data in dev devtest test; do
                for algo in cp; do
                # for TPOPLIM in 02000 01000 00400 00200 00100 00040 00020 00010; do
                for TPOPLIM in $POPLIM; do
                    if [[ $algo == "cp" ]]; then algoid=tl; fi
                    if [[ $algo == "inc" ]]; then algoid=ti; fi
                    SID=$TID-$algoid$TPOPLIM
                    mkdir -p standard-test/$SID
                    if [[ ! -e standard-test/$SID/travatar-$data.ini ]]; then
                        sed "s/filtered-dev/filtered-$data/g" < standard-tune/$TID/travatar.ini > standard-test/$SID/travatar-$data.ini
                        echo "$TRAVDIR/src/bin/travatar -trace_out standard-test/$SID/$data.trace -search $algo -nbest 20 -nbest_out standard-test/$SID/$data.nbest -hiero_span_limit '$SPAN 1000' -pop_limit $TPOPLIM -config_file standard-test/$SID/travatar-$data.ini -threads $THREADS < tok/$data.$SRC > standard-test/$SID/$data.out 2> standard-test/$SID/$data.err"
                        $TRAVDIR/src/bin/travatar -trace_out standard-test/$SID/$data.trace -search $algo -nbest 20 -nbest_out standard-test/$SID/$data.nbest -hiero_span_limit "$SPAN 1000" -pop_limit $TPOPLIM -config_file standard-test/$SID/travatar-$data.ini -threads $THREADS < tok/$data.$SRC > standard-test/$SID/$data.out 2>  standard-test/$SID/$data.err
                        echo "$TRAVDIR/src/bin/mt-evaluator -ref tok/$data.$TRG standard-test/$SID/$data.out > standard-test/$SID/$data.eval"
                        $TRAVDIR/src/bin/mt-evaluator -ref tok/$data.$TRG standard-test/$SID/$data.out > standard-test/$SID/$data.eval
                    fi
                done
                done
            done
        fi
    done
done
done
done
